/*
 * 
 *  dynamic linker command file
 *  generated: Sat May 04 16:21:30 2002

 *  kernel   : legOS
 *  app start: 0xa2f6
 * 
 *  legOS - the independent LEGO Mindstorms OS
 *  (c) 1999 by Markus L. Noga <markus@noga.de>    
 * 
 */

OUTPUT_FORMAT("symbolsrec")
OUTPUT_ARCH(h8300)
ENTRY("_main")

MEMORY {
  rom   : o = 0x0000, l = 0x8000
  kern  : o = 0x8000, l = 0x22f6
  ram   : o = 0xa2f6, l = 0x5c06
  stack : o = 0xfefc, l = 0x0004
  eight : o = 0xff00, l = 0x0100
}

SECTIONS {

  .rom : {
    /* used rom functions */
    
    _rom_reset_vector = 0x0000;
        
    _reset        = 0x03ae ;
    lcd_show      = 0x1b62 ;
    lcd_hide      = 0x1e4a ;
    lcd_number    = 0x1ff2 ;
    lcd_clear     = 0x27ac ;
    power_init    = 0x2964 ;
    sound_system  = 0x299a ;
    power_off     = 0x2a62 ;
    sound_playing = 0x3ccc ;

    _rom_dummy_handler   = 0x046a ;
    _rom_ocia_handler    = 0x04cc ;
    _rom_ocia_return     = 0x04d4 ;
    
  } > rom

  .kernel :	{
    /* kernel symbols (relative to 0x8000) */
    _kmain = 0x0000 ;
    _mm_try_join = 0x00d0 ;
    _mm_update_first_free = 0x0100 ;
    _mm_init = 0x0122 ;
    _malloc = 0x01a8 ;
    _free = 0x024c ;
    _calloc = 0x0276 ;
    _mm_reaper = 0x029e ;
    _systime_handler = 0x030a ;
    _systime_tm_return = 0x0392 ;
    _systime_init = 0x03a2 ;
    _systime_shutdown = 0x03ec ;
    _systime_set_switcher = 0x03f4 ;
    _systime_set_timeslice = 0x03fa ;
    _tm_switcher = 0x0410 ;
    _tm_scheduler = 0x042c ;
    _yield = 0x0620 ;
    _tm_init = 0x063e ;
    _tm_start = 0x0680 ;
    _execi = 0x0690 ;
    _exit = 0x081a ;
    _wait_event = 0x0830 ;
    _msleep = 0x089c ;
    _sleep = 0x08be ;
    _kill = 0x08dc ;
    _killall = 0x0918 ;
    _sem_event_wait = 0x0986 ;
    _sem_wait = 0x099e ;
    _sem_trywait = 0x09be ;
    _sem_post = 0x09d6 ;
    _delay = 0x09e6 ;
    _cputc_native = 0x0a00 ;
    _cputc_native_0 = 0x0a32 ;
    _cputc_native_1 = 0x0a6a ;
    _cputc_native_2 = 0x0aa2 ;
    _cputc_native_3 = 0x0ade ;
    _cputc_native_4 = 0x0b1a ;
    _cputc_native_5 = 0x0b56 ;
    _cputw = 0x0b62 ;
    _cputs = 0x0ba6 ;
    _cls = 0x0bee ;
    _lcd_number = 0x0bf8 ;
    _lcd_refresh_next_byte = 0x0c8a ;
    _lcd_refresh_next_byte_core = 0x0c9e ;
    _lcd_refresh = 0x0cf2 ;
    _lcd_power_on = 0x0d22 ;
    _lcd_power_off = 0x0d34 ;
    _lcd_init = 0x0d50 ;
    _rx_handler = 0x0d98 ;
    _rx_core = 0x0dac ;
    _rxerror_handler = 0x0e22 ;
    _rxerror_core = 0x0e36 ;
    _txend_handler = 0x0e80 ;
    _txend_core = 0x0e94 ;
    _tx_handler = 0x0ea2 ;
    _tx_core = 0x0eb6 ;
    _lnp_logical_shutdown = 0x0ede ;
    _lnp_logical_init = 0x0efe ;
    _lnp_logical_write = 0x0fac ;
    _lnp_integrity_write = 0x1058 ;
    _lnp_addressing_write = 0x10b0 ;
    _lnp_receive_packet = 0x112a ;
    _lnp_integrity_byte = 0x1170 ;
    _lnp_integrity_reset = 0x122e ;
    _lnp_integrity_reset_core = 0x1242 ;
    _lnp_timeout_reset = 0x126e ;
    _lnp_timeout_reset_core = 0x1282 ;
    _lnp_init = 0x128c ;
    _lnp_integrity_active = 0x12ac ;
    _lnp_timeout_set = 0x12b8 ;
    _program_valid = 0x12c2 ;
    _key_handler = 0x1606 ;
    _program_init = 0x1706 ;
    _program_shutdown = 0x174c ;
    _vis_handler = 0x1756 ;
    _vis_core = 0x176a ;
    _get_battery_mv = 0x17be ;
    _battery_refresh = 0x17ec ;
    _battery_refresh_core = 0x1800 ;
    _dkey_handler = 0x182a ;
    _dkey_pressed = 0x1868 ;
    _dkey_released = 0x1876 ;
    _getchar = 0x1896 ;
    _dm_handler = 0x18bc ;
    _dm_init = 0x18fa ;
    _dm_shutdown = 0x18fe ;
    _ds_rotation_set = 0x192c ;
    _ds_rotation_handler = 0x1984 ;
    _ds_init = 0x1a74 ;
    _ds_shutdown = 0x1aaa ;
    _dsound_handler = 0x1ac4 ;
    _dsound_core = 0x1ad8 ;
    _dsound_init = 0x1bd2 ;
    _dsound_shutdown = 0x1bea ;
    _dsound_stop = 0x1bee ;
    _dsound_finished = 0x1c0e ;
    _memset = 0x1c28 ;
    _memcpy = 0x1c36 ;
    ___mulhi3 = 0x1c48 ;
    ___mulsi3 = 0x1c58 ;
    ___divsi3 = 0x1c74 ;
    _hex_display_codes = 0x1cb2 ;
    _ascii_display_codes = 0x1cc2 ;
    _min_length = 0x1d54 ;
    _dm_a_pattern = 0x1d66 ;
    _dm_b_pattern = 0x1d6a ;
    _dm_c_pattern = 0x1d6e ;
    _firmware_string = 0x1e50 ;
    _etext = 0x1e50 ;
    _lcd_refresh_period = 0x1e54 ;
    _lnp_timeout = 0x1e56 ;
    _vis_refresh_counter = 0x1e58 ;
    _vis_refresh_period = 0x1e59 ;
    _battery_refresh_counter = 0x1e5a ;
    _battery_refresh_period = 0x1e5c ;
    _dsound_system_sounds = 0x1e5e ;
    _bss_start = 0x1e60 ;
    __edata = 0x1e60 ;
    _mm_semaphore = 0x2248 ;
    _mm_first_free = 0x224a ;
    _tm_timeslice = 0x224c ;
    _tm_current_slice = 0x224d ;
    _tm_switcher_vector = 0x224e ;
    _sys_time = 0x2250 ;
    _pd_idle = 0x2260 ;
    _cpid = 0x2262 ;
    _nb_tasks = 0x2264 ;
    _priority_head = 0x2266 ;
    _pd_single = 0x2270 ;
    _task_sem = 0x2284 ;
    _lcd_byte_counter = 0x2286 ;
    _lcd_refresh_counter = 0x2287 ;
    _tx_state = 0x2288 ;
    _tx_sem = 0x2289 ;
    _lnp_integrity_handler = 0x2290 ;
    _lnp_timeout_counter = 0x2292 ;
    _lnp_addressing_handler = 0x22a0 ;
    _lnp_integrity_state = 0x22c0 ;
    _packet_len = 0x22c2 ;
    _cprog = 0x22c4 ;
    _packet_src = 0x22c6 ;
    _dkey_timer = 0x22c8 ;
    _dkey = 0x22c9 ;
    _dkey_multi = 0x22ca ;
    _dm_a = 0x22cc ;
    _dm_b = 0x22d0 ;
    _dm_c = 0x22d4 ;
    _ds_rotation = 0x22d8 ;
    _ds_channel = 0x22d9 ;
    _ds_rotations = 0x22e0 ;
    _ds_activation = 0x22e6 ;
    _dsound_next_note = 0x22e8 ;
    _dsound_internote_ms = 0x22ea ;
    _dsound_16th_ms = 0x22ec ;
    _dsound_next_time = 0x22f0 ;
    _end = 0x22f4 ;
    _mm_start = 0x22f4 ;
    /* end of kernel symbols */
  }  > kern
      
  .text BLOCK(2) :	{
    ___text = . ;
    *(.text) 	      /* must start with text for clean entry */			
    *(.rodata)
    *(.strings)
    *(.vectors)       /* vectors region (dummy) */
    *(.persist)

    ___text_end = . ;
  }  > ram

  .tors BLOCK(2) : {
    ___ctors = . ;
    *(.ctors)
    ___ctors_end = . ;
    ___dtors = . ;
    *(.dtors)
    ___dtors_end = . ;
  }  > ram

  .data BLOCK(2) : {
    ___data = . ;
    *(.data)
    *(.tiny)
    ___data_end = . ;
  }  > ram

  .bss BLOCK(2) : {
    ___bss = . ;
    *(.bss)
    *(COMMON)
    ___bss_end = ALIGN(2) ;
  }  >ram

  .stack : {
    _stack = . ; 
    *(.stack)
  }  > topram

  .eight 0xff00: {
    *(.eight)

    /* on-chip module registers (relative to 0xff00) */

    _T_IER = 0x90 ;
    _T_CSR = 0x91 ;
    _T_CNT = 0x92 ;
    _T_OCRA = 0x94 ;
    _T_OCRB = 0x94 ;
    _T_CR = 0x96 ;
    _T_OCR = 0x97 ;
    _T_ICRA = 0x98 ;
    _T_ICRB = 0x9a ;
    _T_ICRC = 0x9c ;
    _T_ICRD = 0x9e ;
    _PORT1_PCR = 0xac ;
    _PORT2_PCR = 0xad ;
    _PORT3_PCR = 0xae ;
    _PORT1_DDR = 0xb0 ;
    _PORT2_DDR = 0xb1 ;
    _PORT1 = 0xb2 ;
    _PORT2 = 0xb3 ;
    _PORT3_DDR = 0xb4 ;
    _PORT4_DDR = 0xb5 ;
    _PORT3 = 0xb6 ;
    _PORT4 = 0xb7 ;
    _PORT5_DDR = 0xb8 ;
    _PORT6_DDR = 0xb9 ;
    _PORT5 = 0xba ;
    _PORT6 = 0xbb ;
    _PORT7 = 0xbe ;
    _STCR = 0xc3 ;
    _SYSCR = 0xc4 ;
    _T0_CR = 0xc8 ;
    _T0_CSR = 0xc9 ;
    _T0_CORA = 0xca ;
    _T0_CORB = 0xcb ;
    _T0_CNT = 0xcc ;
    _T1_CR = 0xd0 ;
    _T1_CSR = 0xd1 ;
    _T1_CORA = 0xd2 ;
    _T1_CORB = 0xd3 ;
    _T1_CNT = 0xd4 ;
    _S_MR = 0xd8 ;
    _S_BRR = 0xd9 ;
    _S_CR = 0xda ;
    _S_TDR = 0xdb ;
    _S_SR = 0xdc ;
    _S_RDR = 0xdd ;
    _AD_A = 0xe0 ;
    _AD_A_H = 0xe0 ;
    _AD_A_L = 0xe1 ;
    _AD_B = 0xe2 ;
    _AD_B_H = 0xe2 ;
    _AD_B_L = 0xe3 ;
    _AD_C = 0xe4 ;
    _AD_C_H = 0xe4 ;
    _AD_C_L = 0xe5 ;
    _AD_D = 0xe6 ;
    _AD_D_H = 0xe6 ;
    _AD_D_L = 0xe7 ;
    _AD_CSR = 0xe8 ;
    _AD_CR = 0xe9 ;
    
    /* end of on-chip module registers */
    
  }  > eight

  .stab 0 (NOLOAD) : {
    [ .stab ]
  }

  .stabstr 0 (NOLOAD) : {
    [ .stabstr ]
  }

} /* SECTIONS */
